//+------------------------------------------------------------------+
//|                                                Indicatorseur.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
extern string suffix="";
extern int timeframe=1440;
extern int shift=0;
extern bool only_history=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   string text=Symbol();
   string substr=StringSubstr(text,6,1);

   displayAUD();
   displayCAD();
   displayCHF();
   displayEUR();
   displayGBP();
   displayJPY();
   displayNZD();
   displayUSD();
   displayAll();
  
   DisplayTime();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll();
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   displayAUD();
   displayCAD();
   displayCHF();
   displayEUR();
   displayGBP();
   displayJPY();
   displayNZD();
   displayUSD();
   displayAll();
   
   DisplayTime();
//----
   return(0);
  }
//+------------------------------------------------------------------+

void displayAUD()
  {
   Display("aud",5,5,5);
   ObjectSetText("aud","AUD",10,"Verdana",Gray);
   Display("audchange",80,5,5);
   ObjectSetText("audchange","change",8,"Verdana",Gray);
   Display("aud_change",150,5,5);
   ObjectSetText("aud_change","%ch",8,"Verdana",Gray);

   string audlist[7]={"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDUSD"};

   double array[5][2];
   for(int a=0;a<5;a++)
     {
      array[a][0] = Percent_Change(audlist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<5;i++)
     {
      int t=array[i][1];
      string ss=audlist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen ;
      if(change<0) currencyclr=Crimson;
      Display("aud_"+i+"",10,(i*12),25);
      ObjectSetText("aud_"+i+"",ss,10,"Verdana",currencyclr);
      Display("aud_"+i+"change",80,(i*12),25);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("aud_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("aud_"+i+"_change",140,(i*12),25);
      double percentChange=Percent_Change(ss);
      ObjectSetText("aud_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayCAD()
  {
   Display("cad",250,5,5);
   ObjectSetText("cad","CAD",10,"Verdana",Gray);
   Display("cadchange",315,5,5);
   ObjectSetText("cadchange","change",8,"Verdana",Gray);
   Display("cad_change",370,5,5);
   ObjectSetText("cad_change","%ch",8,"Verdana",Gray);

   string cadlist[7]={"CADJPY","CADCHF"};

   double array[2][2];
   for(int a=0;a<2;a++)
     {
      array[a][0] = Percent_Change(cadlist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<2;i++)
     {
      int t=array[i][1];
      string ss=cadlist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("cad_"+i+"",250,(i*12),25);
      ObjectSetText("cad_"+i+"",ss,10,"Verdana",currencyclr);
      Display("cad_"+i+"change",315,(i*12),25);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("cad_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("cad_"+i+"_change",370,(i*12),25);
      double percentChange=Percent_Change(ss);
      ObjectSetText("cad_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayCHF()
  {
   Display("chf",5,310,5);
   ObjectSetText("chf","CHF",10,"Verdana",Gray);
   Display("chfchange",90,310,5);
   ObjectSetText("chfchange","change",8,"Verdana",Gray);
   Display("chf_change",150,310,5);
   ObjectSetText("chf_change","%ch",8,"Verdana",Gray);

   string chflist[1]={"CHFJPY"};

   double array[1][2];
   for(int a=0;a<1;a++)
     {
      array[a][0] = Percent_Change(chflist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<1;i++)
     {
      int t=array[i][1];
      string ss=chflist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("chf_"+i+"",10,(i*12),330);
      ObjectSetText("chf_"+i+"",ss,10,"Verdana",currencyclr);
      Display("chf_"+i+"change",80,(i*12),330);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("chf_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("chf_"+i+"_change",150,(i*12),330);
      double percentChange=Percent_Change(ss);
      ObjectSetText("chf_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayEUR()
  {
   Display("eur",5,100,5);
   ObjectSetText("eur","EUR",10,"Verdana",Gray);
   Display("eurchange",80,100,5);
   ObjectSetText("eurchange","change",8,"Verdana",Gray);
   Display("eur_change",150,100,5);
   ObjectSetText("eur_change","%ch",8,"Verdana",Gray);

   string eurlist[7]={"EURAUD","EURNZD","EURCAD","EURUSD","EURGBP","EURCHF","EURJPY"};

   double array[7][2];
   for(int a=0;a<7;a++)
     {
      array[a][0] = Percent_Change(eurlist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<7;i++)
     {
      int t=array[i][1];
      string ss=eurlist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("eur_"+i+"",10,(i*12),120);
      ObjectSetText("eur_"+i+"",ss,10,"Verdana",currencyclr);
      Display("eur_"+i+"change",80,(i*12),120);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("eur_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("eur_"+i+"_change",150,(i*12),120);
      double percentChange=Percent_Change(ss);
      ObjectSetText("eur_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayGBP()
  {
   Display("gbp",250,60,5);
   ObjectSetText("gbp","GBP",10,"Verdana",Gray);
   Display("gbpchange",315,60,5);
   ObjectSetText("gbpchange","change",8,"Verdana",Gray);
   Display("gbp_change",380,60,5);
   ObjectSetText("gbp_change","%ch",8,"Verdana",Gray);

   string gbplist[6]={"GBPAUD","GBPCAD","GBPUSD","GBPCHF","GBPJPY","GBPNZD"};

   double array[6][2];
   for(int a=0;a<6;a++)
     {
      array[a][0] = Percent_Change(gbplist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<6;i++)
     {
      int t=array[i][1];
      string ss=gbplist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("gbp_"+i+"",250,(i*12),80);
      ObjectSetText("gbp_"+i+"",ss,10,"Verdana",currencyclr);
      Display("gbp_"+i+"change",315,(i*12),80);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("gbp_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("gbp_"+i+"_change",380,(i*12),80);
      double percentChange=Percent_Change(ss);
      ObjectSetText("gbp_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayJPY()
  {
   Display("jpy",250,230,5);
   ObjectSetText("jpy","JPY",10,"Verdana",Gray);
   Display("jpychange",315,230,5);
   ObjectSetText("jpychange","change",8,"Verdana",Gray);
   Display("jpy_change",380,230,5);
   ObjectSetText("jpy_change","%ch",8,"Verdana",Gray);

   string jpylist[7]={"AUDJPY","GBPJPY","CADJPY","USDJPY","NZDJPY","CHFJPY","EURJPY"};

   double array[7][2];
   for(int a=0;a<7;a++)
     {
      array[a][0] = Percent_Change(jpylist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<7;i++)
     {
      int t=array[i][1];
      string ss=jpylist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("jpy_"+i+"",250,(i*12),250);
      ObjectSetText("jpy_"+i+"",ss,10,"Verdana",currencyclr);
      Display("jpy_"+i+"change",315,(i*12),250);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("jpy_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("jpy_"+i+"_change",380,(i*12),250);
      double percentChange=Percent_Change(ss);
      ObjectSetText("jpy_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayNZD()
  {
   Display("nzd",5,230,5);
   ObjectSetText("nzd","NZD",10,"Verdana",Gray);
   Display("nzdchange",90,230,5);
   ObjectSetText("nzdchange","change",8,"Verdana",Gray);
   Display("nzd_change",150,230,5);
   ObjectSetText("nzd_change","%ch",8,"Verdana",Gray);

   string nzdlist[7]={"NZDCAD","NZDUSD","NZDCHF","NZDJPY"};

   double array[4][2];
   for(int a=0;a<4;a++)
     {
      array[a][0] = Percent_Change(nzdlist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<4;i++)
     {
      int t=array[i][1];
      string ss=nzdlist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("nzd_"+i+"",10,(i*12),250);
      ObjectSetText("nzd_"+i+"",ss,10,"Verdana",currencyclr);
      Display("nzd_"+i+"change",80,(i*12),250);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("nzd_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("nzd_"+i+"_change",150,(i*12),250);
      double percentChange=Percent_Change(ss);
      ObjectSetText("nzd_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayUSD()
  {
   Display("usd",250,170,5);
   ObjectSetText("usd","USD",10,"Verdana",Gray);
   Display("usdchange",315,170,5);
   ObjectSetText("usdchange","change",8,"Verdana",Gray);
   Display("usd_change",380,170,5);
   ObjectSetText("usd_change","%ch",8,"Verdana",Gray);

   string usdlist[7]={"USDCHF","USDCAD","USDJPY"};

   double array[3][2];
   for(int a=0;a<3;a++)
     {
      array[a][0] = Percent_Change(usdlist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<3;i++)
     {
      int t=array[i][1];
      string ss=usdlist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("usd_"+i+"",250,(i*12),190);
      ObjectSetText("usd_"+i+"",ss,10,"Verdana",currencyclr);
      Display("usd_"+i+"change",315,(i*12),190);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("usd_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("usd_"+i+"_change",380,(i*12),190);
      double percentChange=Percent_Change(ss);
      ObjectSetText("usd_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void displayAll()
  {
   Display("all",450,5,5);
   ObjectSetText("all","ALL",10,"Verdana",Gray);
   Display("allchange",510,5,5);
   ObjectSetText("allchange","change",8,"Verdana",Gray);
   Display("all_change",565,5,5);
   ObjectSetText("all_change","%ch",8,"Verdana",Gray);

   string alllist[28]=
     {
      "GBPNZD","EURNZD","GBPAUD","GBPCAD","GBPJPY","GBPCHF","CADJPY","EURCAD","EURAUD",
      "USDCHF","GBPUSD","EURJPY","NZDJPY","AUDCHF","AUDJPY","USDJPY","EURUSD","NZDCHF",
      "CADCHF","AUDNZD","NZDUSD","CHFJPY","AUDCAD","USDCAD","NZDCAD","AUDUSD","EURCHF","EURGBP"
     };

   double array[28][2];
   for(int a=0;a<28;a++)
     {
      array[a][0] = Percent_Change(alllist[a]);
      array[a][1] = a;
     }
   ArraySort(array,WHOLE_ARRAY,0,MODE_DESCEND);

   for(int i=0;i<28;i++)
     {
      int t=array[i][1];
      string ss=alllist[t];
      double change=Change(ss);
      color currencyclr=SeaGreen;
      if(change<0) currencyclr=Crimson;
      Display("all_"+i+"",450,(i*12),25);
      ObjectSetText("all_"+i+"",ss,10,"Verdana",currencyclr);
      Display("all_"+i+"change",510,(i*12),25);
      int digits=MarketInfo(ss+suffix,MODE_DIGITS);
      ObjectSetText("all_"+i+"change",DoubleToStr(change,digits),8,"Verdana",currencyclr);
      Display("all_"+i+"_change",565,(i*12),25);
      double percentChange=Percent_Change(ss);
      ObjectSetText("all_"+i+"_change",DoubleToStr(percentChange,2)+"%",8,"Verdana",currencyclr);
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DisplayTime()
  {
   Display("time",480,360,5);
   string timestr="";
   switch(timeframe)
     {
      case 1:
         timestr="M1";
         break;
      case 5:
         timestr="M5";
         break;
      case 15:
         timestr="M15";
         break;
      case 30:
         timestr="M30";
         break;
      case 60:
         timestr="H1";
         break;
      case 240:
         timestr="H4";
         break;
      case 1440:
         timestr="Daily";
         break;
      case 10080:
         timestr="Weekly";
         break;
      case 43200:
         timestr="Month";
         break;
      default:
         timestr="Daily";
         break;
     }
   ObjectSetText("time",timestr,12,"Verdana",Gray);
   Display("his_text",300,350,5);
   string his_text="";
   if(only_history) 
     {
      his_text="(history data)";
     }
   ObjectSetText("his_text",his_text,10,"Verdana",Gray);
   Display("opentime",300,350,20);
   string time="";
   datetime itime=iTime(Symbol(),timeframe,shift);
   time=TimeYear(itime)+"-"+TimeMonth(itime)+"-"+TimeDay(itime)+" "+TimeHour(itime)+":"+TimeMinute(itime)+":"+TimeSeconds(itime);
   ObjectSetText("opentime",time,9,"Verdana",Gray);
  }
//----
//----
//----
//----

//-----
//-----

void Display(string name,int x,int y,int relative_YDISTANCE)
  {
   ObjectDelete(name);
   ObjectCreate(name,OBJ_LABEL,0,0,0);
   ObjectSet(name,OBJPROP_CORNER,0);
   ObjectSet(name,OBJPROP_XDISTANCE,x);
   ObjectSet(name,OBJPROP_YDISTANCE,y+relative_YDISTANCE);
   ObjectSet(name,OBJPROP_BACK,FALSE);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Change(string symbol)
  {
//open
   double open= iOpen(symbol,timeframe,shift);
   double bid = MarketInfo(symbol,MODE_BID);
   if(only_history)
     {
      double close=iClose(symbol+suffix,timeframe,shift);
      return close-open;
     }
   return bid-open;
//close
//ask
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Percent_Change(string symbol)
  {
//open
   double change=Change(symbol+suffix);
   double open=iOpen(symbol+suffix,timeframe,shift);
   return change/open*100;
//close
//ask
  }

//-----
//-----
